package cpcns.danganzhengli.wenshu.anjuan.service.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.common.dao.ICommonDao;
import cpcns.common.service.impl.commonServiceImpl;
import cpcns.danganzhengli.wenshu.anjuan.dao.IDAnJuanDao;
import cpcns.danganzhengli.wenshu.anjuan.model.DAnJuan;
import cpcns.danganzhengli.wenshu.anjuan.service.IDAnJuanService;
import cpcns.danganzhengli.wenshu.wenjian.dao.IDWenJianDao;
import cpcns.utils.CommStatic;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.lang.StringUtils;

public class DAnJuanServiceImpl extends commonServiceImpl<DAnJuan> implements IDAnJuanService {
  private IDAnJuanDao dAnJuanDao;
  
  private IDWenJianDao dWenJianDao;
  
  public IDAnJuanDao getdAnJuanDao() {
    return this.dAnJuanDao;
  }
  
  public void setdAnJuanDao(IDAnJuanDao dAnJuanDao) {
    setCommonDao((ICommonDao)dAnJuanDao);
    this.dAnJuanDao = dAnJuanDao;
  }
  
  public IDWenJianDao getdWenJianDao() {
    return this.dWenJianDao;
  }
  
  public void setdWenJianDao(IDWenJianDao dWenJianDao) {
    this.dWenJianDao = dWenJianDao;
  }
  
  public void updateAnJuan(Map<String, String> map1, Map<String, String> map2) {
    StringBuffer sql = new StringBuffer(" Update D_AnJuan set ");
    String t_sql = "";
    for (Map.Entry<String, String> entry : map2.entrySet()) {
      if (t_sql == "") {
        t_sql = String.valueOf(entry.getKey()) + "=" + (String)entry.getValue();
        continue;
      } 
      t_sql = String.valueOf(t_sql) + "," + (String)entry.getKey() + "=" + (String)entry.getValue();
    } 
    sql.append(t_sql).append(" where ");
    for (Map.Entry<String, String> entry : map1.entrySet())
      sql.append(String.valueOf(entry.getKey()) + " in ( " + (String)entry.getValue()).append(" )"); 
    this.dAnJuanDao.updateAnJuan(sql.toString());
  }
  
  public void updateQiZhiShiJian(String server, String hangBiaoShis) {
    if (StringUtils.isNotBlank(hangBiaoShis)) {
      String[] str = hangBiaoShis.split(",");
      if (str.length > 0)
        for (int i = 0; i < str.length; i++) {
          String hangBiaoShi = str[i];
          String qiShiJian = this.dWenJianDao.getChengWenShiJian(hangBiaoShi, 2);
          String zhiShiJian = this.dWenJianDao.getChengWenShiJian(hangBiaoShi, 1);
          StringBuffer sql = new StringBuffer();
          if (StringUtils.isNotBlank(qiShiJian)) {
            sql.append(" Update D_AnJuan set qiShiJian = '" + qiShiJian + "',zhiShiJian='" + zhiShiJian + "' where hangBiaoShi =" + hangBiaoShi);
          } else {
            sql.append(" Update D_AnJuan set qiShiJian = null,zhiShiJian= null where hangBiaoShi =" + hangBiaoShi);
          } 
          this.dAnJuanDao.updateAnJuan(sql.toString());
        }  
    } 
  }
  
  public String addToKuFang(HttpServletRequest request, User user) {
    String falg = "";
    String hangBiaoShis = request.getParameter("hangBiaoShis");
    String[] lis = chuRuKu(request, user).split(";");
    StringBuffer sql = new StringBuffer("update D_AnJuan set ruKuFangZhuangTai=2, kuFangBiaoShi = '" + lis[2] + "',kuFangMingCheng = '" + lis[1] + "' where hangBiaoShi in (" + lis[0] + ")");
    this.dAnJuanDao.updateAnJuan(sql.toString());
    if (StringUtils.isNotBlank(hangBiaoShis)) {
      String[] hangBiaoShi = hangBiaoShis.split(",");
      for (int i = 0; i < hangBiaoShi.length; i++) {
        String biaoShi = hangBiaoShi[i];
        DAnJuan cla = (DAnJuan)this.dAnJuanDao.getById(Integer.valueOf(Integer.parseInt(biaoShi)));
        String menLei = cla.getMenLei();
        if (menLei.equals("WS")) {
          String tabName = CommStatic.getMenLeiToBiaoMing(menLei);
          StringBuffer sqls = new StringBuffer("update " + tabName + " set cunFangWeiZhi='" + lis[1] + "' where guanLianBiaoShi=" + biaoShi);
          this.dAnJuanDao.updateAnJuan(sqls.toString());
        } else {
          String tabName = CommStatic.getMenLeiToBiaoMing(menLei);
          StringBuffer sqls = new StringBuffer("update " + tabName + " set kuFangWeiZhi='" + lis[1] + "' where guanLianBiaoShi=" + biaoShi);
          this.dAnJuanDao.updateAnJuan(sqls.toString());
        } 
      } 
      falg = hangBiaoShis;
    } 
    return falg;
  }
  
  private String chuRuKu(HttpServletRequest request, User user) {
    String hangBiaoShis = "";
    String data = request.getParameter("data");
    String table = request.getParameter("table");
    String result = request.getParameter("result");
    String[] res = result.split(",");
    String kuFangMingCheng = "";
    String[] yuanDA = data.split(";");
    for (int i = 0; i < yuanDA.length; i++) {
      StringBuffer sql = new StringBuffer("insert into D_ChuRuKuDengJi (hangBiaoShi,kuFangBiaoShi,kuFangMingCheng,guanLianBiaoMing,guanLianBiaoShi,tiMing,dangHao,guiDangNianDu,quanZongHao,baoGuanQiXian,zhuangTai,caoZuoRen,caoZuoRenBiaoShi,ruKuShiJian)");
      String[] yDA = yuanDA[i].split(",");
      kuFangMingCheng = getKuFangMingCheng(res[1], res[3]);
      int hbs = this.dAnJuanDao.getPk("D_ChuRuKuDengJi");
      SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
      String time = df.format(new Date());
      sql.append(" values ('" + hbs + "','" + res[1] + "','" + kuFangMingCheng + "','" + table + "','" + Integer.parseInt(yDA[0]) + "','" + yDA[1] + "','" + yDA[2] + "','" + yDA[3] + "','" + yDA[4] + "','" + yDA[5] + "','" + '\001' + "','" + user.getMingCheng() + "','" + user.getBiaoShi() + "',to_date('" + time + "','yyyy-MM-dd'))");
      this.dAnJuanDao.updateAnJuan(sql.toString());
      if (hangBiaoShis == "") {
        hangBiaoShis = yDA[0];
      } else {
        hangBiaoShis = String.valueOf(hangBiaoShis) + "," + yDA[0];
      } 
    } 
    return String.valueOf(hangBiaoShis) + ";" + kuFangMingCheng + ";" + res[1];
  }
  
  private String getKuFangMingCheng(String jieDianBiaoShi, String jieDianGuanXi) {
    String[] jdgx = jieDianGuanXi.split("\\|");
    String kfNum = "";
    kfNum = String.valueOf(jdgx[1]) + "," + jdgx[2] + "," + jieDianBiaoShi;
    StringBuffer nam = new StringBuffer("select MingCheng from D_KuFangFenLei where hangBiaoShi in(" + kfNum + ")");
    List listname = this.dAnJuanDao.getList(nam.toString());
    return (new StringBuilder()).append(listname.get(0)).append("\\").append(listname.get(1)).append("\\").append(listname.get(2)).toString();
  }
  
  public void updateAnJuanZhuangTai(String hangBiaoShis, Integer zhuangTai) {
    StringBuffer sql = new StringBuffer();
    Date date = new Date();
    DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
    String time = format.format(date);
    sql.append("update D_AnJuan set zhuangTai = " + zhuangTai + " where hangBiaoShi in (" + hangBiaoShis + ")");
    this.dAnJuanDao.deletSQL(sql.toString());
    String[] str = hangBiaoShis.split(",");
    if (str.length > 0)
      for (int i = 0; i < str.length; i++) {
        DAnJuan anJuan = (DAnJuan)getById(Integer.valueOf(Integer.parseInt(str[i])));
        String table = CommStatic.getMenLeiToBiaoMing(anJuan.getMenLei());
        StringBuffer sqls = new StringBuffer();
        sqls.append("update " + table + " set zhuangTai = " + zhuangTai);
        if (zhuangTai.intValue() == 0) {
          sqls.append(", guiDangRiQi =to_date(null,'yyyy-MM-dd')");
        } else {
          sqls.append(", guiDangRiQi =to_date('").append(time).append("','yyyy-MM-dd')");
        } 
        sqls.append(" where guiDangLeiXing = 1 and guanLianBiaoShi = " + anJuan.getHangBiaoShi());
        this.dAnJuanDao.deletSQL(sqls.toString());
      }  
  }
  
  public List<Map<String, Object>> getDate(String table, String sqlWhere, User user, String fpbs) {
    String[] ms = sqlWhere.split("and");
    String tj = parseTJ(ms);
    StringBuffer sql = null;
    sql = (new StringBuffer(" select baoGuanQiXian,zongYeShu,biaoTi,guiDangNianDu,beiZhu,xuHao,guanBianAnjuanHao,dangHao from ")).append(table).append(tj);
    if (StringUtils.isNotBlank(fpbs)) {
      sql.append("  order by guiDangNianDu,muLuHao,xuHao asc");
    } else {
      sql.append("  order by xuHao asc");
    } 
    List<Map<String, Object>> list = this.dAnJuanDao.getData(sql);
    return list;
  }
  
  private String parseTJ(String[] ms) {
    String sql = "";
    String hbssql = "";
    if (ms.length > 0) {
      byte b;
      int i;
      String[] arrayOfString;
      for (i = (arrayOfString = ms).length, b = 0; b < i; ) {
        String m = arrayOfString[b];
        if (m.contains("hbs")) {
          String[] hbs = m.split("=");
          if (hbs.length == 2 && StringUtils.isNotBlank(hbs[1].trim()))
            hbssql = " where hangBiaoShi in (" + hbs[1].trim().replaceAll("'", "") + ")"; 
        } else if (!m.contains("_") && !m.contains("hbs")) {
          sql = String.valueOf(sql) + m + " and ";
        } 
        b++;
      } 
      sql = " where 1=1 and " + sql;
    } 
    if (hbssql.length() > 0)
      sql = hbssql; 
    if (sql.trim().endsWith("and"))
      sql = sql.substring(0, sql.length() - 4); 
    return sql;
  }
}
